/*
 *   @(#) MP3 Player 1.0 Demicron (demicron@demicron.com)
 *
 *   bob64.java   2002-09-17
 *
 *   Copyright (C) 2002  Demicron
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

import java.io.*;
import java.net.*;
import java.awt.*;


public class bob64 extends bob implements Runnable {
  static public final String AUDIO_PARAMETER = "audioURL";
  private Play_Player	player = null;
  private String	fileName = null;
  private int startupMode;
  private boolean loop;
  private final static int LOOP = 2;
  private Java11Player oldPlayer;
  private boolean java11 = System.getProperty("java.version").startsWith("1.1");
  private boolean streamed;
  private boolean stopRequested;
  private boolean playing;



  /** Vid play s stts playing till true och play-trden startas
   * vid stop requestas stop och stop pskyndas genom att close/stop krs i playern
   *
   */

  public void i() {
//System.out.println(System.getProperty("os.name"));
    if (java11) {
      fileName = fileName+".au";
    }
    if (!streamed) {
      get(fileName).getData();
    } else {
      m.rm.d.insertElementAt(fileName, 0); // Add to the end of the stack, so that it loads when all resources in the loading manager has finished loading
    }
    if (startupMode!=0) enableSysEv(1);
    enableSysEv(2);
  }

  public void handleSysEv(Event ev) {
    if (ev.id==2) {
      try {
        stop();
      } catch (Exception e) {e.printStackTrace();}
    } else {
      loop = (startupMode==LOOP);
      start();
    }
  }

  public void handleEv(bob arg, int inport) {
    try {
      if (inport<=2) {
        loop = (inport==2);
        start();
      } else if (inport==3) {
        stop();
      }
    } catch (Exception e) {e.printStackTrace();}
    super.handleEv(arg, inport);
  }


  public void rd(DataInputStream dis) {
    try {
      startupMode = dis.readShort();
      fileName = dis.readUTF();
      streamed = dis.readBoolean();
    } catch (Exception e) {e.printStackTrace();}
  }


  /**
   * Starts this applet. An input stream and audio device
   * are created and passed to the play() method.
   */
  public void start()
  {
    if (playing) return;
    stopRequested = false;
    playing = true;
    (new Thread(this)).start();
  }


  /**
   * Stops this applet. If audio is currently playing, it is
   * stopped.
   */
  // Makes run start premature stopping-procedure
  public void stop() {
      if (!stopRequested) {
        stopRequested = true;
          // Speed up stopping-time by stoppping/closing players so that the run-method can start stopping
          try {
              if (oldPlayer!=null) {
                oldPlayer.stop();
              }
              if (player!=null) {
                player.close();
              }
          } catch (Exception ex) {ex.printStackTrace();}
      }
  }


  /**
   * The run method for the audio player thread. Simply calls
   * play() on the player to play the entire stream.
   */
  public void run() {
    InputStream is = get(fileName).is();
    try {

//InputStream is = (new URL(m.rURL,fileName)).openStream();
      if (java11) {
        if (!stopRequested) oldPlayer = new Java11Player(is, this);
        if (!stopRequested)  oldPlayer.play();
        oldPlayer = null;
      } else {
        if (!stopRequested) player = new Play_Player(is);
        if (!stopRequested) player.play();
        player = null;
      }
      is.close(); // S att resourcen lgprioriteras om det inte finns fler resources
      playing = false;
      if (!stopRequested) createEv(null, 1);
      if (!stopRequested && loop) start();
    } catch (Exception ex) {ex.printStackTrace();}
    playing = false;
  }


}